/*
	pkeyaddr: find programmable key storage (int DCh CL=0C/0Dh)
*/

#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef LSI_C
# include <farstr.h>
# define _fmemcpy far_memcpy
# define _fmemcmp far_memcmp
#endif

struct PKEYTBL {
	int offset;
	char *keyname;
	unsigned length;
};
typedef struct PKEYTBL  PKEYTBL;

PKEYTBL pkeytbl_00[] = {
	{ 0x000, "f1", 16 },
	{ 0x010, "f2", 16 },
	{ 0x020, "f3", 16 },
	{ 0x030, "f4", 16 },
	{ 0x040, "f5", 16 },
	{ 0x050, "f6", 16 },
	{ 0x060, "f7", 16 },
	{ 0x070, "f8", 16 },
	{ 0x080, "f9", 16 },
	{ 0x0a0, "shift+f1", 16 },
	{ 0x0b0, "shift+f2", 16 },
	{ 0x0c0, "shift+f3", 16 },
	{ 0x0d0, "shift+f4", 16 },
	{ 0x0e0, "shift+f5", 16 },
	{ 0x0f0, "shift+f6", 16 },
	{ 0x100, "shift+f7", 16 },
	{ 0x110, "shift+f8", 16 },
	{ 0x120, "shift+f9", 16 },
	{ 0x130, "shift+f10", 16 },
	{ 0x140, "Roll Up", 6 },
	{ 0x146, "Roll Down", 6 },
	{ 0x14c, "Ins", 6 },
	{ 0x152, "Del", 6 },
	{ 0x158, "up", 6 },
	{ 0x15e, "left", 6 },
	{ 0x164, "right", 6 },
	{ 0x16a, "down", 6 },
	{ 0x170, "Home", 6 },
	{ 0x176, "Help", 6 },
	{ 0x17c, "shift+Home", 6 },
	{ -1, NULL, 0 }
};

PKEYTBL pkeytbl_ff[] = {
	{ 0x000, "f1", 16 },
	{ 0x010, "f2", 16 },
	{ 0x020, "f3", 16 },
	{ 0x030, "f4", 16 },
	{ 0x040, "f5", 16 },
	{ 0x050, "f6", 16 },
	{ 0x060, "f7", 16 },
	{ 0x070, "f8", 16 },
	{ 0x080, "f9", 16 },
	{ 0x090, "f10", 16 },
	{ 0x0a0, "vf1", 16 },
	{ 0x0b0, "vf2", 16 },
	{ 0x0c0, "vf3", 16 },
	{ 0x0d0, "vf4", 16 },
	{ 0x0e0, "vf5", 16 },
	{ 0x0f0, "shift+f1", 16 },
	{ 0x100, "shift+f2", 16 },
	{ 0x110, "shift+f3", 16 },
	{ 0x120, "shift+f4", 16 },
	{ 0x130, "shift+f5", 16 },
	{ 0x140, "shift+f6", 16 },
	{ 0x150, "shift+f7", 16 },
	{ 0x160, "shift+f8", 16 },
	{ 0x170, "shift+f9", 16 },
	{ 0x180, "shift+f10", 16 },
	{ 0x190, "shift+vf1", 16 },
	{ 0x1a0, "shift+vf2", 16 },
	{ 0x1b0, "shift+vf3", 16 },
	{ 0x1c0, "shift+vf4", 16 },
	{ 0x1d0, "shift+vf5", 16 },
	{ 0x1e0, "Roll Up", 6 },
	{ 0x1e6, "Roll Down", 6 },
	{ 0x1ec, "Ins", 6 },
	{ 0x1f2, "Del", 6 },
	{ 0x1f8, "up", 6 },
	{ 0x1fe, "left", 6 },
	{ 0x204, "right", 6 },
	{ 0x20a, "down", 6 },
	{ 0x210, "Home", 6 },
	{ 0x216, "Help", 6 },
	{ 0x21c, "shift+Home", 6 },
	{ 0x222, "ctrl+f1", 16 },
	{ 0x232, "ctrl+f2", 16 },
	{ 0x242, "ctrl+f3", 16 },
	{ 0x252, "ctrl+f4", 16 },
	{ 0x262, "ctrl+f5", 16 },
	{ 0x272, "ctrl+f6", 16 },
	{ 0x282, "ctrl+f7", 16 },
	{ 0x292, "ctrl+f8", 16 },
	{ 0x2a2, "ctrl+f9", 16 },
	{ 0x2b2, "ctrl+f10", 16 },
	{ 0x2c2, "ctrl+vf1", 16 },
	{ 0x2d2, "ctrl+vf2", 16 },
	{ 0x2e2, "ctrl+vf3", 16 },
	{ 0x2f2, "ctrl+vf4", 16 },
	{ 0x302, "ctrl+vf5", 16 },
	{ -1, NULL, 0 }
};

PKEYTBL pkeytbl_39[] = {
	{ 0x000, "ctrl+xfer", 16 },
	{ -1, NULL, 0 }
};

PKEYTBL pkeytbl_3a[] = {
	{ 0x000, "ctrl+xfer", 16 },
	{ 0x010, "ctrl+f1", 16 },
	{ 0x020, "ctrl+f2", 16 },
	{ 0x030, "ctrl+f3", 16 },
	{ 0x040, "ctrl+f4", 16 },
	{ 0x050, "ctrl+f5", 16 },
	{ 0x060, "ctrl+f6", 16 },
	{ 0x070, "ctrl+f7", 16 },
	{ 0x080, "ctrl+f8", 16 },
	{ 0x090, "ctrl+f9", 16 },
	{ 0x0a0, "ctrl+f10", 16 },
	{ -1, NULL, 0 }
};



static
void far *
findmem(const void far *s_mem, unsigned s_len, const void *key_mem, unsigned key_len)
{
	void far *found = 0;
	const char far *p = s_mem;
	
	if (key_len > 0 && s_len >= key_len) {
		s_len -= key_len;
		while(s_len) {
			if (_fmemcmp(p, key_mem, key_len) == 0) {
				found = (void far *)p;
				break;
			}
			++p;
			--s_len;
		}
	}
	
	return found;
}

int
find_pkey(const PKEYTBL *pk, unsigned func_type)
{
	int rc = 0;
	union REGS r;
	struct SREGS sr;
	unsigned iolen;
	void far *iosys;
	char *pkey, *pkey0;
	unsigned pkey_buflen = 0x312;

	r.h.ah = 0x52;
	intdosx(&r, &r, &sr);
	
	iolen = (sr.es - 0x60) * 16U;
	iosys = MK_FP(0x60, 0);
#if 0
	printf("io.sys %Fp len=0x%04x\n", iosys, iolen);
#endif
	pkey = malloc(pkey_buflen);
	pkey0 = malloc(pkey_buflen);
	if (!pkey || !pkey0) {
		fprintf(stderr, "fatal: memory allocation failure.\n");
		exit(1);
	}

	memset(pkey0, 0, pkey_buflen);
	r.h.cl = 0x0c;
	r.x.ax = func_type; /* 0x00ff; */
	r.x.dx = FP_OFF(pkey0);
	sr.ds = FP_SEG(pkey0);
	int86x(0xdc, &r, &r, &sr);
	
	while(pk->offset >= 0) {
		void far *k;
		memcpy(pkey, pkey0, pkey_buflen);
		memset(pkey + pk->offset, 'z', pk->length - 1);
		r.h.cl = 0x0d;
		r.x.ax = func_type; /* 0x00ff; */
		r.x.dx = FP_OFF(pkey);
		sr.ds = FP_SEG(pkey);
		int86x(0xdc, &r, &r, &sr);
		k = findmem(iosys, iolen, pkey + pk->offset, pk->length - 1);
		if (k) {
			printf("%Fp %s\n", k, pk->keyname);
		}
		else {
			rc = -1;
			break;
		}
		++pk;
	}
	
	r.h.cl = 0x0d;
	r.x.ax = func_type; /* 0x00ff; */
	r.x.dx = FP_OFF(pkey0);
	sr.ds = FP_SEG(pkey0);
	int86x(0xdc, &r, &r, &sr);
	
	return rc;
}



int main(void)
{
	
	if (find_pkey(pkeytbl_ff, 0xff) != 0) {
		find_pkey(pkeytbl_00, 0x00);
	}
	find_pkey(pkeytbl_39, 0x39);
	
	return 0;
}
